#
# AtlantisBlueCMS CMS.py
#
# note: 2003-04-05 dhart
#       - class & function overwrites/rewrites from CMF & Plone
#       - other changes of the type found in Portal.PloneGenerator()
#
import string

from Globals import ImageFile, DTMLFile, InitializeClass
from AccessControl import ClassSecurityInfo
from Products.CMFCore.CMFCorePermissions import ManagePortal
from Products.CMFCore.utils import getToolByName
from Products.CMFPlone import Portal
from Products.AtlantisBlueCMS import CMSFolder, CMSPage

security = ClassSecurityInfo()

#
# CMFPlone.Portal.py section
#

class CMSSite(Portal.PloneSite,CMSPage.CMSPage):
    """
    Atlantis Blue CMS - Site Root Container.
    """

    CMS_site_properties =     [ ('title', 'Title'), 
				('fullname', 'Full Name'), 
				('legalname', 'Legal Name'), 
				('abbr', 'Abbreviation')
			      ]

     #key: cms_type,cms_display_type,meta_type,plone_display_file,title_display,file_status
    CMS_content_types     =    ['page,Page,CMS Page,folder,Title,optional',
				'text,Text Block,Document,document,None,optional',
				'graphic,Graphic,Portal Image,image,Caption,required',
				'file,File,Portal File,file,Title,required'
			       ]

    icon_abbrs	=		{	'application/pdf' : 'pdf' ,

					'application/msword' : 'doc' ,
					'text/richtext' : 'doc' ,
					'text/rtf' : 'doc' ,

    					'application/vnd.ms-excel' : 'xls' ,
    					'text/comma-separated-values' : 'xls' ,

					'image/gif' : 'img' ,
					'image/jpeg' : 'img' ,
					'image/png' : 'img' ,

    					'text/plain' : 'unk' ,
    					'text/html' : 'unk' 
				}


    # override the ZMI folder view
    manage_main = DTMLFile('dtml/manage_main', globals())


    security.declareProtected(ManagePortal, 'cmsSetSiteProperties')
    def cmsSetSiteProperties(self, REQUEST=None):
     """
     Sets CMS Site Properties like Full Name, Legal Name, etc.
     """
     properties = REQUEST.form
     vhroot     = self.getSiteRoot()
     if properties.has_key('submit'):
       del properties['submit']
     for id,value in properties.items():
       if not vhroot.hasProperty(id):
         vhroot.manage_addProperty(id, value, 'string')
       else:
         property = {}
         property[id]=value
         vhroot.manage_changeProperties(property)
     return self.cmsadmin()

